#LogTo("rank4t.log");;

#we invoke the file basic.g:
Read("/home/agustin/Dropbox/math/in-progress/conjecture/gap/basic.g");


#in this file we list all of the rank 4 diagrams in Heckenberger's list: they are either lines, tripods (D4) or tadpoles.

u:=F1;;

d1q:=q->[q,q^-1,q,q^-1,q,F1,q,q^-1,F1,F1];;
#li

d2q:=function(q)
if q<>-F1 then return
[q^2,q^-2,q^2,q^-2,q^2,F1,q,q^-2,F1,F1];
else return 0;
fi;
end;
#li

d3q:=function(q)
if q<>-F1 then return
[q,q^-1,q,q^-1,q,F1,q^2,q^-2,F1,F1];
else return 0;
fi;
end;
#li

d4q:=function(q)
if q<>-F1 then return
[q^2,q^-2,q^2,q^-2,q,F1,q,q^-1,F1,F1];
else return 0;
fi;
end;
#li

d5q:=function(q)
if q<>F1 then return
[q,u,q,q^-1,q,q^-1,q,q^-1,u,u];
else return 0;
fi;
end;
#tr

d6aq:=function(q)
if q<>-F1 then return
[-u,q^-1,q,q^-1,q,u,q,q^-1,u,u];
else return 0;
fi;
end;
#li

d6bq:=function(q)
if q<>-F1 then return
[-u,q,-u,q^-1,q,u,q,q^-1,u,u];
else return 0;
fi;
end;
#li

d6cq:=function(q)
if q<>-F1 then return
[q,q^-1,-u,q,-u,u,q,q^-1,u,u];
else return 0;
fi;
end;
#li

d7aq:=function(q)
if q^4<>F1 then return
[-u,q^-2,q^2,q^-2,q^2,u,q,q^-2,u,u];
else return 0;
fi;
end;
#li

d7bq:=function(q)
if q^4<>F1 then return
[-u,q^2,-u,q^-2,q^2,u,q,q^-2,u,u];
else return 0;
fi;
end;
#li

d7cq:=function(q)
if q^4<>F1 then return
[q^2,q^-2,-u,q^2,-u,u,q,q^-2,u,u];
else return 0;
fi;
end;
#li

d7dq:=function(q)
if q^4<>F1 then return
[q^2,q^-2,q^2,q^-2,-u,u,-q^-1,q^2,u,u];
else return 0;
fi;
end;
#li

d8aq:=function(q)
if q^2<>F1 then return
[-u,q^-1,q,q^-1,q,u,q^2,q^-2,u,u];
else return 0;
fi;
end;
#li

d8bq:=function(q)
if q^2<>F1 then return
[-u,q,-u,q^-1,q,u,q^2,q^-2,u,u];
else return 0;
fi;
end;
#li

d8cq:=function(q)
if q^2<>F1 then return
[q,q^-1,-u,q,-u,u,q^2,q^-2,u,u];
else return 0;
fi;
end;
#li

d8dq:=function(q)
if q^2<>F1 then return
[-u,q^2,-u,q^-1,q,q^-1,q,q^-1,u,u];
else return 0;
fi;
end;
#ta

d9aq:=function(q)
if q^2<>F1 and q^3<>F1 then return
[q^2,q^-2,q^2,q^-2,q,u,-u,q^-1,u,u];
else return 0;
fi;
end;
#li

d9bq:=function(q)
if q^2<>F1 and q^3<>F1 then return
[q^2,q^-2,q^2,q^-2,-u,u,-u,q,u,u];
else return 0;
fi;
end;
#li

d9cq:=function(q)
if q^2<>F1 and q^3<>F1 then return
[q,q^-1,-u,q^2,-u,q^-1,q^2,q^-2,u,u];
else return 0;
fi;
end;
#ta

d9dq:=function(q)
if q^2<>F1 and q^3<>F1 then return
[-u,q^-3,-u,q^2,-u,q,q^2,q^-2,u,u];
else return 0;
fi;
end;
#ta

d9eq:=function(q)
if q^2<>F1 and q^3<>F1 then return
[q^2,q^-2,q^2,q^-2,-u,u,q^-3,q^3,u,u];
else return 0;
fi;
end;
#li

d9fq:=function(q)
if q^2<>F1 and q^3<>F1 then return
[q^2,q^-2,q,q^-1,-u,u,q^-3,q^3,u,u];
else return 0;
fi;
end;
#li

d10aq:=function(q)
if q^2<>F1 then return
[q^-1,q,-u,q^-1,q,u,q,q^-1,u,u];
else return 0;
fi;
end;
#li

d10bq:=function(q)
if q^2<>F1 then return
[-u,q^-1,-u,q,-u,u,q,q^-1,u,u];
else return 0;
fi;
end;
#li

d10cq:=function(q)
if q^2<>F1 then return
[-u,q,q^-1,q,-u,u,q,q^-1,u,u];
else return 0;
fi;
end;
#li

d10dq:=function(q)
if q^2<>F1 then return
[-u,q^-1,q,q^-1,-u,u,-u,q,u,u];
else return 0;
fi;
end;
#li

d10eq:=function(q)
if q^2<>F1 then return
[-u,q^-1,q,q^-1,q,u,-u,q^-1,u,u];
else return 0;
fi;
end;
#li

d10fq:=function(q)
if q^2<>F1 then return
[-u,q,-u,q^-1,-u,u,-u,q,u,u];
else return 0;
fi;
end;
#li


d11aq:=function(q)
if q^4<>F1 then return
[q^-2,q^2,-u,q^-2,q^2,u,q,q^-2,u,u];
else return 0;
fi;
end;
#li

d11bq:=function(q)
if q^4<>F1 then return
[-u,q^-2,-u,q^2,-u,u,q,q^-2,u,u];
else return 0;
fi;
end;
#li

d11cq:=function(q)
if q^4<>F1 then return
[-u,q^2,q^-2,q^2,-u,u,q,q^-2,u,u];
else return 0;
fi;
end;
#li

#d11d=d11c
#d11e=d11b
#d11f=d11a


d12aq:=function(q)
if q^2<>F1 then return
[q^-1,q,-u,q^-1,q,u,q^2,q^-2,u,u];
else return 0;
fi;
end;
#li

d12bq:=function(q)
if q^2<>F1 then return
[-u,q^-1,-u,q,-u,u,q^2,q^-2,u,u];
else return 0;
fi;
end;
#li

d12cq:=function(q)
if q^2<>F1 then return
[-u,q,q^-1,q,-u,u,q^2,q^-2,u,u];
else return 0;
fi;
end;
#li

d12dq:=function(q)
if q^2<>F1 then return
[-u,q^2,-u,q^-1,q,q^-1,-u,q^-1,u,u];
else return 0;
fi;
end;
#ta

d12eq:=function(q)
if q^2<>F1 then return
[-u,q^2,-u,q^-1,-u,q^-1,-u,q,u,u];
else return 0;
fi;
end;
#ta

d12fq:=function(q)
if q^2<>F1 then return
[q,u,q^-1,q,-u,q^-1,q^-1,q,u,u];
else return 0;
fi;
end;
#tr

d13aq:=function(q)
if q^2<>F1 then return
[q,q^-1,q,q^-1,-u,u,q^-2,q^2,u,u];
else return 0;
fi;
end;
#li

d13bq:=function(q)
if q^2<>F1 then return
[-u,q^-2,-u,q,-u,q,q,q^-1,u,u];
else return 0;
fi;
end;
#ta

d13cq:=function(q)
if q^2<>F1 then return
[-u,u,q,q^-1,-u,q,q,q^-1,u,u];
else return 0;
fi;
end;
#tr

d13dq:=function(q)
if q^2<>F1 then return
[-u,u,q,q^-1,q,q^-1,q,q^-1,u,u];
else return 0;
fi;
end;
#tr

d14aq:=function(q)
if q^2<>F1 then return
[q,q^-1,q,q^-1,-u,u,-q^-1,-q,u,u];
else return 0;
fi;
end;
#li

d14bq:=function(q)
if q^2<>F1 then return
[-u,-q^-1,-u,q,-u,-u,q,q^-1,u,u];
else return 0;
fi;
end;
#ta

d14cq:=function(q)
if q^2<>F1 then return
[q,q^-1,-u,-u,-u,u,-q^-1,-q,u,u];
else return 0;
fi;	
end;
#li

r4q:=[
d1q,d2q,d3q,d4q,d5q,
d6aq,d6bq,d6cq,
d7aq,d7bq,d7cq,d7dq,
d8aq,d8bq,d8cq,d8dq,
d9aq,d9bq,d9cq,d9dq,d9eq,d9fq,
d10aq,d10bq,d10cq,d10dq,d10eq,d10fq,
d11aq,d11bq,d11cq,
d12aq,d12bq,d12cq,d12dq,d12eq,d12fq,
d13aq,d13bq,d13cq,d13dq,
d14aq,d14bq,d14cq
];;

tr4q:=[d5q,d12fq,d13cq,d13dq];;
ta4q:=[d8dq,d9cq,d9dq,d12dq,d12eq,d13bq,d14bq];;
li4q:=[];;
for d in r4q do
	if d in tr4q or d in ta4q then
	d:=d;	
	else 
	Add(li4q,d);
	fi;
od; 


r4qq:=[];;
for d in r4q do
	for n in Gf do
		if d(n)<>0 then
		Add(r4qq,d(n));
		fi;
	od;
od;

tr4qq:=[];;
for d in tr4q do
	for n in Gf do
		if d(n)<>0 then
		Add(tr4qq,d(n));
		fi;
	od;
od;

ta4qq:=[];;
for d in ta4q do
	for n in Gf do
		if d(n)<>0 then
		Add(ta4qq,d(n));
		fi;
	od;
od;

li4qq:=[];;
for d in li4q do
	for n in Gf do
		if d(n)<>0 then
		Add(li4qq,d(n));
		fi;
	od;
od;


z:=F(3);;

d15:=[-z^2,-z,-z^2,-z,-z^2,u,z,-z,u,u];;
#li

d16a:=[-u,-z,-z^2,-z,-z^2,u,z,-z,u,u];;
#li
d16b:=[-u,-z^2,-u,-z,-z^2,u,z,-z,u,u];;
#li
d16c:=[-z^2,-z,-u,-z^2,-u,u,z,-z,u,u];;
#li
d16d:=[-z^2,-z,-z^2,-z,-u,u,z^2,-z^2,u,u];;
#li

d17a:=[-z,-z^2,-z,-z^2,-z,u,z,-z^2,u,u];;
#li
d17b:=[-z,-z^2,-z,-z^2,-u,u,z,-u,u,u];;
#li
d17c:=[z,-u,-u,-z,-u,z^2,-z,-z^2,u,u];;
#ta
d17d:=[-u,-z,-u,-z,-u,z,-z,-z^2,u,u];;
#ta
d17e:=[-z,-z^2,z,z^2,-u,u,-z,-z^2,u,u];;
#li
d17f:=[-z,-z^2,-z,-z^2,-u,u,-z,-z^2,u,u];;
#li

d18a:=[z^2,z,z^2,z,z,u,-u,z^2,u,u];;
#li
d18b:=[z^2,z,z^2,z,-u,u,-u,z,u,u];;
#li
d18c:=[z,z^2,-u,z^2,-u,z^2,z^2,z,u,u];;
#ta
d18d:=[z^2,u,-u,z^2,-u,z,-u,z,u,u];;
#tr
d18e:=[z^2,u,-u,z^2,z,z,-u,z^2,u,u];;
#tr
d18f:=[z^2,u,-u,z,z^2,z,-u,z,u,u];;
#tr

d19a:=[-z,-z^2,-u,-z,-z^2,u,z,-z,u,u];;
#li
d19b:=[-u,-z,-u,-z^2,-u,u,z,-z,u,u];;
#li
d19c:=[-u,-z^2,-z,-z^2,-u,u,z,-z,u,u];;
#li

d20a:=[z^2,z,-u,z^2,z,u,-u,z,u,u];;
#li
d20b:=[z^2,z,-u,z^2,-z^2,u,-u,z^2,u,u];;
#li
d20c:=[-u,z^2,-u,z,-u,u,-u,z,u,u];;
#li
d20d:=[-u,z,z^2,z,-u,u,-u,z,u,u];;
#li
d20e:=[-u,z^2,-u,z,z,u,-u,z^2,u,u];;
#li
d20f:=[-u,z,z^2,z,z,u,-u,z^2,u,u];;
#li
d20g:=[z,z^2,-u,z^2,z,z^2,-u,z^2,u,u];;
#ta
d20h:=[z,z^2,-u,z^2,-u,z^2,-u,z,u,u];;
#ta
d20i:=[z,u,z^2,z,-u,z^2,-u,z,u,u];;
#tr
d20j:=[z,u,z^2,z,z,z^2,-u,z^2,u,u];;
#tr

d21a:=[-u,z^2,z,z^2,z,u,-u,z,u,u];;
#li
d21b:=[-u,z^2,z,z^2,-z^2,u,-u,z^2,u,u];;
#li
d21c:=[-u,z,-u,z^2,z,u,-u,z,u,u];;
#li
d21d:=[-u,z,-u,z^2,-z^2,u,-u,z^2,u,u];;
#li
d21e:=[z,z^2,-u,z,z,u,-u,z^2,u,u];;
#li
d21f:=[z,z^2,-u,z,-u,u,-u,z,u,u];;
#li
d21g:=[z,z^2,-u,z^2,z,z^2,z,z^2,u,u];;
#ta


z:=F(3)^2;;


d15p:=[-z^2,-z,-z^2,-z,-z^2,u,z,-z,u,u];;
#li

d16ap:=[-u,-z,-z^2,-z,-z^2,u,z,-z,u,u];;
#li
d16bp:=[-u,-z^2,-u,-z,-z^2,u,z,-z,u,u];;
#li
d16cp:=[-z^2,-z,-u,-z^2,-u,u,z,-z,u,u];;
#li
d16dp:=[-z^2,-z,-z^2,-z,-u,u,z^2,-z^2,u,u];;
#li

d17ap:=[-z,-z^2,-z,-z^2,-z,u,z,-z^2,u,u];;
#li
d17bp:=[-z,-z^2,-z,-z^2,-u,u,z,-u,u,u];;
#li
d17cp:=[z,-u,-u,-z,-u,z^2,-z,-z^2,u,u];;
#ta
d17dp:=[-u,-z,-u,-z,-u,z,-z,-z^2,u,u];;
#ta
d17ep:=[-z,-z^2,z,z^2,-u,u,-z,-z^2,u,u];;
#li
d17fp:=[-z,-z^2,-z,-z^2,-u,u,-z,-z^2,u,u];;
#li

d18ap:=[z^2,z,z^2,z,z,u,-u,z^2,u,u];;
#li
d18bp:=[z^2,z,z^2,z,-u,u,-u,z,u,u];;
#li
d18cp:=[z,z^2,-u,z^2,-u,z^2,z^2,z,u,u];;
#ta
d18dp:=[z^2,u,-u,z^2,-u,z,-u,z,u,u];;
#tr
d18ep:=[z^2,u,-u,z^2,z,z,-u,z^2,u,u];;
#tr
d18fp:=[z^2,u,-u,z,z^2,z,-u,z,u,u];;
#tr

d19ap:=[-z,-z^2,-u,-z,-z^2,u,z,-z,u,u];;
#li
d19bp:=[-u,-z,-u,-z^2,-u,u,z,-z,u,u];;
#li
d19cp:=[-u,-z^2,-z,-z^2,-u,u,z,-z,u,u];;
#li

d20ap:=[z^2,z,-u,z^2,z,u,-u,z,u,u];;
#li
d20bp:=[z^2,z,-u,z^2,-z^2,u,-u,z^2,u,u];;
#li
d20cp:=[-u,z^2,-u,z,-u,u,-u,z,u,u];;
#li
d20dp:=[-u,z,z^2,z,-u,u,-u,z,u,u];;
#li
d20ep:=[-u,z^2,-u,z,z,u,-u,z^2,u,u];;
#li
d20fp:=[-u,z,z^2,z,z,u,-u,z^2,u,u];;
#li
d20gp:=[z,z^2,-u,z^2,z,z^2,-u,z^2,u,u];;
#ta
d20hp:=[z,z^2,-u,z^2,-u,z^2,-u,z,u,u];;
#ta
d20ip:=[z,u,z^2,z,-u,z^2,-u,z,u,u];;
#tr
d20jp:=[z,u,z^2,z,z,z^2,-u,z^2,u,u];;
#tr

d21ap:=[-u,z^2,z,z^2,z,u,-u,z,u,u];;
#li
d21bp:=[-u,z^2,z,z^2,-z^2,u,-u,z^2,u,u];;
#li
d21cp:=[-u,z,-u,z^2,z,u,-u,z,u,u];;
#li
d21dp:=[-u,z,-u,z^2,-z^2,u,-u,z^2,u,u];;
#li
d21ep:=[z,z^2,-u,z,z,u,-u,z^2,u,u];;
#li
d21fp:=[z,z^2,-u,z,-u,u,-u,z,u,u];;
#li
d21gp:=[z,z^2,-u,z^2,z,z^2,z,z^2,u,u];;
#ta

x:=F(4);;

d22a:=[-x,x,-u,-x,x,u,-x,x,u,u];;
#li
d22b:=[-u,-x,-u,x,-u,u,-x,x,u,u];;
#li
d22c:=[-u,x,-x,x,-u,u,-x,x,u,u];;
#li
d22d:=[-u,-x,-u,-x,x,-u,-u,-x,u,u];;
#ta
d22e:=[-u,-x,-u,-x,-u,-u,-u,x,u,u];;
#ta
d22f:=[-u,-x,x,-u,-u,u,-x,x,u,u];;
#li
d22g:=[-u,x,-u,-u,-u,u,-x,x,u,u];;
#li
d22h:=[-u,-x,x,-x,-u,-u,-x,x,u,u];;
#ta

x:=-F(4);;
d22ap:=[-x,x,-u,-x,x,u,-x,x,u,u];;
#li
d22bp:=[-u,-x,-u,x,-u,u,-x,x,u,u];;
#li
d22cp:=[-u,x,-x,x,-u,u,-x,x,u,u];;
#li
d22dp:=[-u,-x,-u,-x,x,-u,-u,-x,u,u];;
#ta
d22ep:=[-u,-x,-u,-x,-u,-u,-u,x,u,u];;
#ta
d22fp:=[-u,-x,x,-u,-u,u,-x,x,u,u];;
#li
d22gp:=[-u,x,-u,-u,-u,u,-x,x,u,u];;
#li
d22hp:=[-u,-x,x,-x,-u,-u,-x,x,u,u];;
#ta

r4f:=[
d15,
d16a,d16b,d16c,d16d,
d17a,d17b,d17c,d17d,d17e,d17f,
d18a,d18b,d18c,d18d,d18e,d18f,
d19a,d19b,d19c,d19c,
d20a,d20b,d20c,d20d,d20e,d20f,d20g,d20h,d20i,
d21a,d21b,d21c,d21d,d21e,d21f,d21g,
d22a,d22b,d22c,d22d,d22e,d22f,d22g,d22h,
d15p,
d16ap,d16bp,d16cp,d16dp,
d17ap,d17bp,d17cp,d17dp,d17ep,d17fp,
d18ap,d18bp,d18cp,d18dp,d18ep,d18fp,
d19ap,d19bp,d19cp,
d20ap,d20bp,d20cp,d20dp,d20ep,d20fp,d20gp,d20hp,d20ip,
d21ap,d21bp,d21cp,d21dp,d21ep,d21fp,d21gp,
d22a,d22b,d22c,d22d,d22e,d22f,d22g,d22h,
d22ap,d22bp,d22cp,d22dp,d22ep,d22fp,d22gp,d22hp
];;

ta4f:=[d17c,d17d,d18c,d20g,d20h,d21g,d22d,d22e,d22h,d17cp,d17dp,d18cp,d20gp,d20hp,d21gp,d22dp,d22ep,d22hp];;
tr4f:=[d18d,d18e,d18f,d20i,d20j,d18dp,d18ep,d18fp,d20ip,d20jp];;

li4f:=[];;
for d in r4f do
	if d in tr4f or d  in ta4f then
	d:=d;
	else
	Add(li4f,d);
	fi;
od; 

Hr4:=Zet(Concatenation(r4qq,r4f));;

########
#tadpoles
########

Hta4s:=Zet(Concatenation(ta4qq,ta4f));;

Hta4p:=[];
for d in Hta4s do
Add(Hta4p,Permuted(d,(1,3)(4,6)));
od;

Hta4:=Zet(Concatenation(Hta4s,Hta4p));;

########################################
#lines
########################################

Hli4s:=Zet(Concatenation(li4qq,li4f));;


Hli4p:=[];
for d in Hli4s do
Add(Hli4p,Permuted(d,(1,7)(2,8)(3,5)));
od;

Hli4:=Zet(Concatenation(Hli4s,Hli4p));;


########################################
#tripods (d4)
########################################

Htr4s:=Zet(Concatenation(tr4qq,tr4f));;


Htr4p:=[];
for d in Htr4s do
Add(Htr4p,Permuted(d,(1,3)(4,6)));
Add(Htr4p,Permuted(d,(1,3,7)(6,4,8)));
Add(Htr4p,Permuted(d,(1,7,3)(6,8,4)));
Add(Htr4p,Permuted(d,(3,7)(4,8)));
Add(Htr4p,Permuted(d,(1,7)(6,8)));
od;


Hd4:=Zet(Concatenation(Htr4s,Htr4p));;

############




